package cc.fascinated.bat.features.base.commands.general;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import cc.fascinated.bat.common.DescriptionBuilder;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "vote", description = "Vote for the bot", guildOnly = false, userInstall = true, category = Category.GENERAL)
public class VoteCommand extends BatCommand {
    private static final String[] VOTE_LINKS = new String[]{
            "https://top.gg/bot/1254161119975833652/vote",
            "https://discordbotlist.com/bots/bat/upvote"
    };

    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, Message commandMessage, String[] arguments, SlashCommandInteraction event) {
        DescriptionBuilder description = new DescriptionBuilder("Vote Links");
        description.appendLine("Vote for the bot on the following websites to support us!", false);
        for (String link : VOTE_LINKS) {
            description.appendLine(link, true);
        }
        event.replyEmbeds(EmbedUtils.genericEmbed()
                .setDescription(description.build())
                .build()
        ).queue();
    }
}
