package cc.fascinated.bat.features.base.commands.utility.lookup;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Nick (okNick)
 */
@Component
@CommandInfo(
        name = "lookup",
        description = "View the banner of the guild or a user",
        userInstall = true,
        category = Category.UTILITY
)
public class LookupCommand extends BatCommand {
    @Autowired
    public LookupCommand(@NonNull ApplicationContext context) {
        super.addSubCommands(
                context.getBean(UserSubCommand.class)
        );
    }
}