package cc.fascinated.bat.features.moderation.punish;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;

/**
 * @author Fascinated (fascinated7)
 */
@AllArgsConstructor
@Getter
@Setter
public class Punishment {
    /**
     * The type of punishment
     */
    private final PunishmentType type;

    /**
     * The reason for the punishment
     */
    private final String reason;

    /**
     * The member who issued out this punishment
     */
    private final String issuer;

    /**
     * The date the punishment was issued
     */
    private final Date issuedDate;

    /**
     * The time the punishment will end, if temporary
     */
    private Date endDate;

    /**
     * If the punishment has expired
     */
    private boolean expired;
}
