package cc.fascinated.bat.features.welcomer.command;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import net.dv8tion.jda.api.Permission;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "welcomer", description = "Configure the welcomer on your server", requiredPermissions = Permission.MANAGE_SERVER, category = Category.SERVER)
public class WelcomerCommand extends BatCommand {
    @Autowired
    public WelcomerCommand(@NonNull ApplicationContext context) {
        super.addSubCommands(
                context.getBean(MessageSubCommand.class),
                context.getBean(EmbedSubCommand.class),
                context.getBean(CurrentSubCommand.class),
                context.getBean(ChannelSubCommand.class),
                context.getBean(ResetSubCommand.class)
        );
    }
}
